---
title: PushSubscription
slug: Web/API/PushSubscription
tags:
  - API
  - Experimental
  - Interface
  - Push
  - Push API
  - PushSubscription
  - Reference
  - Service Workers
---
<div>{{SeeCompatTable}}{{ApiRef("Push API")}} </div>

<p>The <code>PushSubscription</code> interface of the <a href="/en-US/docs/Web/API/Push_API">Push API</a> provides a subcription's URL endpoint and allows unsubscription from a push service.</p>

<p>An instance of this interface can be serialized.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("PushSubscription.endpoint")}} {{readonlyinline}}</dt>
 <dd>A {{domxref("USVString")}} containing the endpoint associated with the push subscription.</dd>
 <dt>{{domxref("PushSubscription.expirationTime")}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} of the subscription expiration time associated with the push subscription, if there is one, or null otherwise. </dd>
 <dt>{{domxref("PushSubscription.options")}} {{readonlyinline}}</dt>
 <dd>An object containing the options used to create the subscription.</dd>
</dl>

<dl>
 <dt>{{domxref("PushSubscription.subscriptionId")}} {{deprecated_inline}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} containing the subscription ID associated with the push subscription.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("PushSubscription.getKey()")}}</dt>
 <dd>Returns an {{domxref("ArrayBuffer")}} which contains the client's public key, which can then be sent to a server and used in encrypting push message data.</dd>
 <dt>{{domxref("PushSubscription.toJSON()")}}</dt>
 <dd>Standard serializer — returns a JSON representation of the subscription properties.</dd>
 <dt>{{domxref("PushSubscription.unsubscribe()")}}</dt>
 <dd>Starts the asynchronous process of unsubscribing from the push service, returning a {{jsxref("Promise")}} that resolves to a {{domxref("Boolean")}} when the current subscription is successfully unregistered.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">navigator.serviceWorker.ready.then(function(reg) {
  reg.pushManager.getSubscription().then(function(subscription) {
    subscription.unsubscribe().then(function(successful) {
      // You've successfully unsubscribed
    }).catch(function(e) {
      // Unsubscription failed
    })
  })
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Push API", "#pushsubscription-interface", "PushSubscription")}}</td>
   <td>{{Spec2("Push API")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PushSubscription")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Push_API">Push API</a></li>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API</a></li>
</ul>
